#!/usr/local/bin/ruby

#!/bin/sh

nr_serial = 20
nr_parrarel = 50
wwwdir = '/var/www/loadtest/'
urllist = 'urllist'
urlform = "http://localhost:3622/loadtest/%d.txt\n"
load_size = 128 * 1024

case ARGV[0]
when 'init'
  for i in 1 .. nr_serial
    print "writing #{i}...\n"
    fd = open(wwwdir + i.to_s + '.txt', 'w')
    for j in 0 .. load_size
      fd.putc rand(256).chr
    end
    fd.close
  end
when 'list'
  system('rm -r work*')
  fd = open(wwwdir + urllist, 'w')
  for i in 1 .. nr_serial
    fd.printf(urlform, i)
  end
  fd.close
else
  #print "Usage: #{$0} init | doit\n"
  for i in 1 .. nr_parrarel
    fork() do
      wd = 'work' + i.to_s
      Dir.mkdir(wd)
      Dir.chdir(wd)
      exec('wget', '-q', '-i', wwwdir + urllist)
    end
  end
  for i in 1 .. nr_parrarel
    pid = Process.wait
    print "pid #{pid} exit, total #{i} exited\n"
  end
end
